From ed8ea9bd9e3ee75dfaff4b9affac95afa579d1fe Mon Sep 17 00:00:00 2001
From: Ricardo Lafuente <r@manufacturaindependente.org>
Date: Feb 06 2024 16:14:41 +0000
Subject: [PATCH 15/17] Merge branch 'website-i18n' into website


---

diff --git a/common/fp_report.js b/common/fp_report.js
index 4798d25..f9f44e3 100644
--- a/common/fp_report.js
+++ b/common/fp_report.js
@@ -21,6 +21,8 @@
 //  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 //
 
+let hiddenTraces = {};
+
 /**
  * Event listener that listens for a load of FPD report page. If the page is loaded, fetch FPD data from background.
  *
@@ -79,6 +81,8 @@ function createReport(data) {
 			if (groups.all[group].description) {
 				html += "<div id=\"" + group + "\" class=\"fpd-group access\">";
 				html += "<h2>" + group + "</h2>";
+				html += `<button class="help" id="expand${group}" >⤵</button>`;
+				html += "<section>";
 				html += "<p>" + groups.all[group].description + "</p>";
 			}
 			for (let [item, type] of Object.entries(groups.all[group].items)) {
@@ -90,7 +94,7 @@ function createReport(data) {
 				}
 			}
 			if (groups.all[group].description) {
-				html += "</div>";
+				html += "</section></div>";
 			}
 		}
 	}
@@ -103,17 +107,16 @@ function createReport(data) {
 				for (let t of Object.values(fpDb[resource])) {
 					let traces = Object.keys(t.callers);
 					for (trace of traces) {
-						if (trace !== "") {
-							callers += "<br><br>" + trace;
+						if (trace !== "" && !(trace in hiddenTraces)) {
+							callers += "<p>" + trace.replace(/\n/g, '<br>') + "</p>";
 						}
 					}
 				}
 			}
-			callers = callers.replace(/\n/g, '<br>');
 			let accessRaw = processedEvals[resource].total;
 			let accessCount = accessRaw >= 1000 ? "1000+" : accessRaw;
-			html += `<h4 class="hidden ${accessRaw > 0 ? "access" : "no-access"}"><span class="dot">-</span> ` +
-			`${resource} (${exceptionWrappers.includes(resource) ? "n/a" : accessCount})\n${callers}</h4>`;
+			html += `<div class="details ${accessRaw > 0 ? "access" : "no-access"}"><h4><span class="dot">-</span> ` +
+			`${resource} (${exceptionWrappers.includes(resource) ? "n/a" : accessCount})</h4>\n${callers}</div>`;
 		}
 	}
 
@@ -127,7 +130,7 @@ function createReport(data) {
 	for (let i = groupElements.length; i > 0; i--) {
 		// remove duplicit entries from groups
 		let duplicitArray = [];
-		let elements = groupElements[i-1].querySelectorAll(":scope > h4");
+		let elements = groupElements[i-1].querySelectorAll(":scope > section > div.details > h4");
 		elements.forEach((d) => {
 			if (duplicitArray.indexOf(d.innerHTML) > -1) {
 				d.remove();
@@ -138,49 +141,45 @@ function createReport(data) {
 		});
 
 		// hide groups with no relevant entries
-		if (!document.querySelectorAll(`#${groupElements[i-1].id} > .access`).length) {
+		if (!document.querySelectorAll(`#${groupElements[i-1].id} > section > .access`).length) {
 			groupElements[i-1].classList.replace("access", "no-access");
 		}
 	}
 
 	// function that enables to show accessed resources of the group
-	let toggleResources = (event) => {
+	function toggleResources(event) {
 		let parent =  event.target.parentElement;
 		for (let i = 0; i < parent.children.length; i++) {
 			let child = parent.children[i];
-			if (child.tagName == "H4") {
+			if (child.tagName == "SECTION") {
 				child.classList.toggle("hidden");
 			}
 		}
 	}
 
 	// make group name clickable only if it makes sense - groups with resources
-	let makeClickableTitles = () => {
+	function makeGroupExpansionsClickable() {
 		for (let element of document.querySelectorAll(".fpd-group")) {
 			let button;
-			let haveChild = false;
 
 			for (let i = 0; i < element.children.length; i++) {
 				let child = element.children[i];
-				if (child.tagName == "H2") {
+				if (child.tagName == "BUTTON") {
 					button = child;
 				}
-				if (child.tagName == "H4" && !child.classList.contains("no-access")) {
-					haveChild = true;
-				}
 			}
 
-			if (button && haveChild) {
+			if (button) {
 				button.classList.add("clickable");
 				button.addEventListener("click", toggleResources);
 			}
 		}
 	}
-	makeClickableTitles();
+	makeGroupExpansionsClickable();
 
 	// show resources for every group in FPD report
 	let showAll = (event) => {
-		for (let element of document.querySelectorAll(".fpd-group > h4")) {
+		for (let element of document.querySelectorAll(".fpd-group div.details")) {
 			element.classList.remove("hidden");
 		}
 		showBtn.classList.add("hidden");
@@ -189,28 +188,40 @@ function createReport(data) {
 
 	// hide resources for every group in FPD report
 	let hideDetails = (event) => {
-		for (let element of document.querySelectorAll(".fpd-group > h4")) {
+		for (let element of document.querySelectorAll(".fpd-group div.details")) {
 			element.classList.add("hidden");
 		}
 		showBtn.classList.remove("hidden");
 		hideBtn.classList.add("hidden");
 	}
+	hideDetails();
+
+	// refresh data in the report
+	function refreshReport() {
+		browser.runtime.sendMessage({
+			purpose: "fpd-get-report-data",
+			tabId: tabId
+		}).then((result) => {
+			createReport(result);
+			showAll();
+		});
+		browser.runtime.sendMessage({purpose: "fpd-track-callers-stop"});
+		document.getElementById("updateReportBtn").classList.remove("hidden");
+		document.getElementById("forgetCurrentBtn").classList.remove("hidden");
+		let trackCallersBtn = document.getElementById("trackCallersBtn");
+		trackCallersBtn.innerText = browser.i18n.getMessage("FPDReportTrackCallersRestart");
+		trackCallersBtn.classList.remove("hidden");
+	}
 
 	// Reload the report with data on the identity of the calling scripts
 	function trackCallers() {
 		tabId = new URLSearchParams(window.location.search).get("id");
 		function onReloaded() {
-			function refresh() {
-				browser.runtime.sendMessage({
-					purpose: "fpd-get-report-data",
-					tabId: tabId
-				}).then((result) => {
-					createReport(result);
-					showAll();
-				});
-				browser.runtime.sendMessage({purpose: "fpd-track-callers-stop"});
-			}
-			setInterval(refresh, 5000);
+			setTimeout(refreshReport, 5000);
+			report.innerHTML = browser.i18n.getMessage("FPDReportTrackCallersWaiting");
+			document.getElementById("trackCallersBtn").classList.add("hidden");
+			document.getElementById("updateReportBtn").classList.add("hidden");
+			document.getElementById("forgetCurrentBtn").classList.add("hidden");
 		}
 		function onError(error) {
 			document.getElementById("fpdError").innerHTML = browser.i18n.getMessage("FPDReportTrackCallersFailed", error);
@@ -222,12 +233,26 @@ function createReport(data) {
 		}).then(onReloaded, onError);
 	}
 
+	function updateReport() {
+	}
+
 	// show all groups/resources even if not accessed
 	let showNotAccessed = () => {
 		for (let element of document.querySelectorAll(".no-access")) {
 			element.classList.remove("no-access");
 		}
-		makeClickableTitles();
+		makeGroupExpansionsClickable();
+	}
+
+	function forgetTraces() {
+		for (resource of Object.values(fpDb)) {
+			for (type of Object.values(resource)) {
+				for (trace of Object.keys(type.callers)) {
+					hiddenTraces[trace] = true;
+				}
+			}
+		}
+		createReport(data);
 	}
 
 	// create on-site JSON representation of FPD evaluation data and download it
@@ -249,6 +274,8 @@ function createReport(data) {
 	document.getElementById("hideBtn").onclick = hideDetails;
 	document.getElementById("exportBtn").onclick = exportReport.bind(null, `fpd_report_${url}.json`);
 	document.getElementById("trackCallersBtn").onclick = trackCallers;
+	document.getElementById("forgetCurrentBtn").onclick = forgetTraces;
+	document.getElementById("updateReportBtn").onclick = refreshReport;
 	document.getElementById("unhideAll").onclick = showNotAccessed;
 }
 
diff --git a/common/levels.js b/common/levels.js
index 014feb3..1786695 100644
--- a/common/levels.js
+++ b/common/levels.js
@@ -932,8 +932,8 @@ function updateLevels(res) {
 	default_level.is_default = true;
 	var redefined_domains = res["domains"] || {};
 	for (let [d, settings] of Object.entries(tweak_domains)) {
-		if ((settings.level_id === default_level.level_id) && !(d in redefined_domains)) {
-			redefined_domains[d] = settings;
+		if ((default_level.level_id in settings.level_id) && !(d in redefined_domains)) {
+			redefined_domains[d] = {level_id: default_level.level_id, tweaks: settings.tweaks};
 		}
 	}
 	for (let [d, {level_id, tweaks, restore, restore_tweaks}] of Object.entries(redefined_domains)) {
@@ -983,27 +983,9 @@ function saveDomainLevels() {
 		if (k[k.length - 1] === ".") {
 			k = k.substring(0, k.length-1);
 		}
-		// Do not save built-in tweaks as they are automatically added in updateLevels
-		if (k in tweak_domains) {
-			// Skip further check if the user has a different default_level
-			if (tweak_domains[k].level_id === default_level.level_id) {
-				tdb_tweaks = Object.entries(tweak_domains[k].tweaks);
-				current_tweaks = Object.entries(domains[k].tweaks);
-				if (tdb_tweaks.length === current_tweaks.length) {
-					var equal = true;
-					for ([name, val] of tdb_tweaks) {
-						if (domains[k].tweaks[name] !== val) {
-							equal = false;
-							break;
-						}
-					}
-					if (equal) {
-						// This entry should not be saved
-						continue;
-					}
-				}
-			}
-		}
+		// Tweaks not contain the new value defined by the user. However, that might
+		// be the value of the level. Remove such tweaks as they to not change the
+		// level of protection
 		if (tweaks) {
 			for (let [group, param] of Object.entries(tweaks)) {
 				if (param === (levels[level_id][group] || 0)) {
@@ -1013,6 +995,27 @@ function saveDomainLevels() {
 			if (Object.keys(tweaks).length === 0) {
 				tweaks = undefined;
 			}
+			// Do not save built-in tweaks as they are automatically added in updateLevels
+			if (k in tweak_domains) {
+				// Skip further check if the user has a different default_level
+				if (default_level.level_id in tweak_domains[k].level_id) {
+					tdb_tweaks = Object.entries(tweak_domains[k].tweaks);
+					current_tweaks = Object.entries(tweaks || {});
+					if (tdb_tweaks.length === current_tweaks.length) {
+						var equal = true;
+						for ([name, val] of tdb_tweaks) {
+							if (tweaks[name] !== val) {
+								equal = false;
+								break;
+							}
+						}
+						if (equal) {
+							// This entry should not be saved
+							continue;
+						}
+					}
+				}
+			}
 		}
 		tobesaved[k] = tweaks ? {level_id, tweaks} : {level_id};
 		if (restore) {
diff --git a/common/options_advanced.js b/common/options_advanced.js
index d8f0488..ce2641b 100644
--- a/common/options_advanced.js
+++ b/common/options_advanced.js
@@ -73,24 +73,31 @@ document.getElementById("levels-storage-undo").addEventListener("click", async f
 });
 
 window.addEventListener("DOMContentLoaded", function() {
-	function appendElement(type, innerHtml) {
+	function appendElement(innerText, type="span") {
 		let el = document.createElement(type);
-		el.innerHTML = innerHtml;
+		el.innerText = innerText;
 		parent.appendChild(el);
 		return el;
 	}
 	let parent = document.getElementById("builtin-jss-tweaks");
+	if (Object.keys(tweak_domains_builtin).length > 0) {
+		appendElement(browser.i18n.getMessage("JSSBuiltinExceptionsDomain"), "h4");
+		appendElement(browser.i18n.getMessage("JSSBuiltinExceptionsLevels"), "h4");
+		appendElement(browser.i18n.getMessage("JSSBuiltinExceptionsChanges"), "h4");
+		appendElement(browser.i18n.getMessage("JSSBuiltinExceptionsReason"), "h4");
+	}
 	for ([d, settings] of Object.entries(tweak_domains_builtin)) {
-		appendElement("h4", d);
-		appendElement("p", browser.i18n.getMessage("JSSBuiltinExceptionsAppliedTo",
-			levels[settings.level_id].level_text) + ` <a href="${settings.explanation}">${settings.explanation}</a>`);
-		var currentTweaksEl = appendElement("div", "");
+		appendElement(d).classList.add("tweak_domain");
+		appendElement((settings.level_id.map((id) => levels[id].level_text)).join(browser.i18n.getMessage("JSSBuiltinExceptionsLevelsSeparator")));
+		let currentTweaksEl = appendElement("", "div");
 		currentTweaksEl.classList.add("tweakgrid");
 		let tweaksBusiness = Object.create(tweaks_gui);
 		tweaksBusiness.get_current_tweaks = function() {
 			return settings.tweaks;
 		};
 		tweaksBusiness.create_tweaks_html(currentTweaksEl);
+		let reasonEl = appendElement(settings.explanation, "a");
+		reasonEl.href = settings.explanation;
 	}
 });
 
diff --git a/common/popup.js b/common/popup.js
index 272afc4..a7d7adb 100644
--- a/common/popup.js
+++ b/common/popup.js
@@ -119,7 +119,7 @@ function enableRefreshIfNeeded() {
 /**
  * Save level settings for current page, show correct button
  */
-function modify_level(level, levelButton) {
+function modify_level(level, levelButton, forceUpdateLevels = false) {
 	if (level) {
 		current_level = level;
 		saveDomainLevels();
@@ -127,7 +127,16 @@ function modify_level(level, levelButton) {
 			changeActiveLevel(levelButton);
 		}
 		update_level_info();
-		update_tweaks();
+		if (forceUpdateLevels) {
+			function refresh() {
+				current_level = getCurrentLevelJSON("https://" + site);
+				update_tweaks();
+			}
+			browser.storage.sync.get(null).then(updateLevels).then(refresh);
+		}
+		else {
+			update_tweaks();
+		}
 	}
 }
 
@@ -207,7 +216,7 @@ function add_level_buttons() {
 	default_lev_button = addButton({level_id: "DEFAULT", level_description: browser.i18n.getMessage("popupDefaultLevelHelpText"), level_text: browser.i18n.getMessage("defaultLevelSelection", default_level.level_text)});
 	default_lev_button.addEventListener("click", ev => {
 		delete domains[site];
-		modify_level(default_level, ev.target);
+		modify_level(default_level, ev.target, true); // We need to force update config to display built-in tweaks
 	});
 	// Load built-in and custom levels
 	for (let level_id in levels) {
diff --git a/common/settings_tweaks.js b/common/settings_tweaks.js
index c7e0d71..314e042 100644
--- a/common/settings_tweaks.js
+++ b/common/settings_tweaks.js
@@ -23,14 +23,14 @@
 var tweak_domains_builtin = {
 	"docs.google.com": {
 		"explanation": "https://pagure.io/JShelter/webextension/issue/122",
-		"level_id": "2",
+		"level_id": ["1", "2"],
 		"tweaks": {
 			"webworker": 2
 		}
 	},
 	"app.mediafire.com": {
 		"explanation": "https://github.com/polcak/jsrestrictor/issues/207",
-		"level_id": "2",
+		"level_id": ["1", "2"],
 		"tweaks": {
 			"webworker": 2
 		}
diff --git a/tests/integration_tests/testing/web_browser.py b/tests/integration_tests/testing/web_browser.py
index 7831b3b..0989f6c 100644
--- a/tests/integration_tests/testing/web_browser.py
+++ b/tests/integration_tests/testing/web_browser.py
@@ -96,15 +96,23 @@ class Browser:
                     self._jsr_options_page = elem.text.split(',')[2].split('=')[1][:-1] + "options.html"
         if self.type == BrowserType.CHROME:
             self.driver.get('chrome://system/')
-            WebDriverWait(self.driver, 10).until(
-                ec.presence_of_element_located((By.ID, 'expandAll'))
-            )
-            self.driver.find_element(By.ID, 'expandAll').click()
+            try:
+                WebDriverWait(self.driver, 2).until(
+                    ec.presence_of_element_located((By.ID, 'expandAll'))
+                )
+                self.driver.find_element(By.ID, 'expandAll').click()
+            except:
+                self.driver.find_elements(By.TAG_NAME, 'system-app')[0].shadow_root.find_elements(By.CSS_SELECTOR, 'button')[0].click()
             sleep(1)
             try:
                 extensions = self.driver.find_element(By.ID, 'div-extensions-value')
             except NoSuchElementException:
-                extensions = self.driver.find_element(By.ID, 'extensions-value')
+                try:
+                    extensions = self.driver.find_element(By.ID, 'extensions-value')
+                except NoSuchElementException:
+                    system_app = self.driver.find_elements(By.TAG_NAME, 'system-app')[0].shadow_root
+                    log_entry = system_app.find_elements(By.CSS_SELECTOR, 'log-entry')[5].shadow_root
+                    extensions = log_entry.find_elements(By.CLASS_NAME, 'stat-value')[0]
             for elem in extensions.text.splitlines():
                 if 'JShelter' in elem:
                     self._jsr_options_page = "chrome-extension://" + elem.split(':')[0][:-1] + "/options.html"
diff --git a/website/Makefile b/website/Makefile
index 48cd818..5d534df 100644
--- a/website/Makefile
+++ b/website/Makefile
@@ -52,37 +52,45 @@ install:
 extract:
 	$(ACTIVATE); python extract_comments.py
 
-html: extract
+translate:
+	$(ACTIVATE); cd i18n; ./download.sh; ./translate_content.sh; for f in `ls ../content/posts/pt/*.md`; do ./postprocess.py $$f; done; for f in `ls ../content/pages/pt/*.md`; do ./postprocess.py $$f; done; for f in `ls ../content/wrappers/*.md`; do ./postprocess.py $$f; done
+
+html: extract 
 	cp ../tests/integration_tests/README.md content/pages/integration_tests.md
 	cp ../tests/unit_tests/README.md content/pages/unit_tests.md
 	mkdir -p output/ output/.well-known/
 	cp -r theme/favicon.ico output/
 	cp -r theme/security.txt output/.well-known/
 	$(ACTIVATE); python extract_comments.py
-	$(ACTIVATE); $(PELICAN) "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(CONFFILE)" $(PELICANOPTS)
+	$(PELICAN) "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(CONFFILE)" $(PELICANOPTS)
 	# fix translated indexes to address a Pelican bug
-	cd content/pages; for lang in */; do mv ../../output/$$lang/$$lang/index.html ../../output/$$lang; rm -f ../../output/$$lang/$$lang/index.html; done
+	# cd content/pages; for lang in */; do mv ../../output/$$lang/$$lang/index.html ../../output/$$lang; rm -f ../../output/$$lang/$$lang/index.html; done
+
+build: translate html
 
 clean:
 	[ ! -d "$(OUTPUTDIR)" ] || rm -rf "$(OUTPUTDIR)"
+	rm -fr content/pages/pt
+	rm -fr content/posts/pt
+	rm -fr content/wrappers/pt
 
 regenerate:
-	$(ACTIVATE); $(PELICAN) -r "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(CONFFILE)" $(PELICANOPTS)
+	$(PELICAN) -r "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(CONFFILE)" $(PELICANOPTS)
 
 serve:
-	$(ACTIVATE); $(PELICAN) -l "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(CONFFILE)" $(PELICANOPTS)
+	$(PELICAN) -l "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(CONFFILE)" $(PELICANOPTS)
 
 serve-global:
-	$(ACTIVATE); $(PELICAN) -l "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(CONFFILE)" $(PELICANOPTS) -b $(SERVER)
+	$(PELICAN) -l "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(CONFFILE)" $(PELICANOPTS) -b $(SERVER)
 
 devserver:
-	$(ACTIVATE); $(PELICAN) -lr "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(CONFFILE)" $(PELICANOPTS)
+	$(PELICAN) -lr "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(CONFFILE)" $(PELICANOPTS)
 
 devserver-global:
-	$(ACTIVATE); $(PELICAN) -lr $(INPUTDIR) -o $(OUTPUTDIR) -s $(CONFFILE) $(PELICANOPTS) -b 0.0.0.0
+	$(PELICAN) -lr $(INPUTDIR) -o $(OUTPUTDIR) -s $(CONFFILE) $(PELICANOPTS) -b 0.0.0.0
 
 publish:
-	$(ACTIVATE); $(PELICAN) "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(PUBLISHCONF)" $(PELICANOPTS)
+	$(PELICAN) "$(INPUTDIR)" -o "$(OUTPUTDIR)" -s "$(PUBLISHCONF)" $(PELICANOPTS)
 
 deploy: html
 	rsync -e "ssh -p 22" -P -rvzc output/ root@jshelter.org:/var/www/html/ --cvs-exclude
diff --git a/website/i18n/build_po_files.sh b/website/i18n/build_po_files.sh
new file mode 100755
index 0000000..918a49a
--- /dev/null
+++ b/website/i18n/build_po_files.sh
@@ -0,0 +1,27 @@
+#!/bin/bash
+#
+# Generates .po files from the original Markdown source files.
+#
+
+mkdir -p en
+
+for f in ../content/pages/*.md; do
+  md2po --quiet \
+    --po-encoding=UTF-8 $f --save --merge-po-files --po-filepath en/pages.po \
+    -d "Content-Type: text/plain; charset=utf-8" 
+  # -d ”Language: es”
+done
+
+for f in ../content/posts/*.md; do
+  md2po --quiet \
+    --po-encoding=UTF-8 $f --save --merge-po-files --po-filepath en/posts.po \
+    -d "Content-Type: text/plain; charset=utf-8" 
+  # -d ”Language: es”
+done
+
+for f in ../content/wrappers/*.md; do
+  md2po --quiet \
+    --po-encoding=UTF-8 $f --save --merge-po-files --po-filepath en/wrappers.po \
+    -d "Content-Type: text/plain; charset=utf-8" 
+  # -d ”Language: es”
+done
diff --git a/website/i18n/download.sh b/website/i18n/download.sh
new file mode 100755
index 0000000..543bd70
--- /dev/null
+++ b/website/i18n/download.sh
@@ -0,0 +1,11 @@
+#!/bin/bash
+#
+# Updates the local translation files with the most recent Weblate versions.
+#
+
+for lang in `ls -d */ | sed 's/\///' | grep -v '^en$'`; do
+  echo $lang
+  wlc download jshelter/website/$lang >| $lang/pages.po
+  wlc download jshelter/website-posts/$lang >| $lang/posts.po
+  wlc download jshelter/website-wrappers/$lang >| $lang/wrappers.po
+done
diff --git a/website/i18n/postprocess.py b/website/i18n/postprocess.py
new file mode 100755
index 0000000..6d232b4
--- /dev/null
+++ b/website/i18n/postprocess.py
@@ -0,0 +1,49 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+#
+# Apply some post-processing to deal with broken 
+# lines in the Markdown frontmatter in the Weblate
+# translated files. Accepts a file as argument and
+# overwrites it with the processed version.
+
+import sys
+
+FIELDNAMES = ["Series", "series_index", "Date", "Modified"]
+
+with open(sys.argv[1], 'r') as f:
+    lines = f.readlines()
+
+# first pass: join all lines
+raw_frontmatter = ""
+for line in lines:
+    if not line.strip():
+        break
+    raw_frontmatter += line.strip() + ' '
+
+# remove header markup if present
+if raw_frontmatter.startswith('# '):
+    raw_frontmatter = raw_frontmatter.replace('# ', '', 1)
+if raw_frontmatter.startswith('## '):
+    raw_frontmatter = raw_frontmatter.replace('## ', '', 1)
+if raw_frontmatter.startswith('### '):
+    raw_frontmatter = raw_frontmatter.replace('### ', '', 1)
+
+# second pass: break lines on field names
+output = raw_frontmatter
+for name in FIELDNAMES:
+    tag = name + ": "
+    if tag in raw_frontmatter:
+        output = output.replace(tag, '\n' + tag)
+
+# now combine frontmatter and content
+output += '\n'
+frontmatter_ended = False
+for line in lines:
+    if not line.strip():
+        frontmatter_ended = True
+    if not frontmatter_ended:
+        continue
+    output += line
+
+with open(sys.argv[1], 'w') as f:
+    f.write(output)
diff --git a/website/i18n/translate_content.sh b/website/i18n/translate_content.sh
new file mode 100755
index 0000000..4033099
--- /dev/null
+++ b/website/i18n/translate_content.sh
@@ -0,0 +1,14 @@
+#!/bin/bash
+#
+# Generates translated content files from the .po sources
+
+for lang in `ls -d */ | sed 's/\///' | grep -v '^en$'`; do
+  for section in 'pages' 'posts' 'wrappers'; do
+    mkdir -p ../content/$section/$lang # /content/pages/pt
+    echo "Translating $section for language $lang..."
+    for f in `ls ../content/$section/*.md`; do
+       # echo $f
+       po2md $f -p $lang/$section.po >| ${f/$section/$section\/$lang}
+    done
+  done
+done
